// ==========================================================================
// $Source: /home/cvs/linbox/linbox/util/gmp++/gmp++_int_compare.C,v $
// Copyright(c)'94-97 by Givaro Team
// see the copyright file.
// Authors: M. Samama, T. Gautier
// $Id: gmp++_int_compare.C,v 1.8 2005/06/02 09:48:06 dumas Exp $
// ==========================================================================

#ifndef LinBoxSrcOnly
#include "gmp++_int.h"
#endif

// returns 1 if a > b, 0 if a == b and -1 otherwise.  
int compare(const Integer &a, const Integer& b) 
{
  return mpz_cmp ( (mpz_ptr)&a.gmp_rep, (mpz_ptr)&b.gmp_rep );
}

int absCompare(const Integer &a, const Integer &b) 
{
  return mpz_cmpabs( (mpz_ptr)&(a.gmp_rep), (mpz_ptr)&(b.gmp_rep));
}

int Integer::operator != (const int l) const 
{ return mpz_cmp_si ( (mpz_ptr)&gmp_rep, l ) != 0; }

int Integer::operator != (const long l) const 
{ return mpz_cmp_si ( (mpz_ptr)&gmp_rep, l ) != 0; }

//unsigned long ops added by Dan Roche, 6-26-04
int Integer::operator != (const unsigned long l) const
{ return mpz_cmp_ui ( (mpz_ptr)&gmp_rep, l ) != 0; }

int Integer::operator > (const int l) const 
{ return mpz_cmp_si((mpz_ptr)&gmp_rep, l) > 0; }

int Integer::operator > (const long l) const 
{ return mpz_cmp_si((mpz_ptr)&gmp_rep, l) > 0; }

int Integer::operator > (const unsigned long l) const
{ return mpz_cmp_ui((mpz_ptr)&gmp_rep, l) > 0; }

int Integer::operator < (const int l) const 
{ return mpz_cmp_si((mpz_ptr)&gmp_rep, l) < 0; }

int Integer::operator < (const long l) const 
{ return mpz_cmp_si((mpz_ptr)&gmp_rep, l) < 0; }

int Integer::operator < (const unsigned long l) const
{ return mpz_cmp_ui((mpz_ptr)&gmp_rep, 1) < 0; }
